/*
 * Copyright 2022 University of Liège
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef WFORWARDEULER_H
#define WFORWARDEULER_H

#include "waves.h"
#include "wTimeIntegration.h"

namespace waves
{

/**
 * @brief simple explicit Forward Euler time integration
 */

class WAVES_API ForwardEuler : public TimeIntegration
{
public:
    ForwardEuler(std::shared_ptr<Problem> _pbl);
    virtual ~ForwardEuler() { std::cout << "~ForwardEuler()\n"; }

    virtual void start(tbox::MshExport *mshWriter) override;
    virtual char const *clsname() const override { return "ForwardEuler"; }
};

} // namespace waves

#endif //WFORWARDEULER_H
